﻿# L-PFR+ informacije o izmenama - Windows v1.0.1. (rev. 21)

## v1.0.1 (rev. 21)
*Datum: 07.03.2023.*
- Automatska optimizacija baze prilikom pokretanja servisa i pre slanja dijagnostike

## v1.0.1 (rev. 18)
*Datum: 31.01.2023.*
 
- Usklađeni statusi greške koji se mogu dobiti kao odgovor prilikom slanja računa ka serveru Poreske uprave
- Podrška za automatsko ponovno slanje računa u slučaju greške sa odgovarajućim statusom
- Dodatna validacija polja BuyerId kojom se dozvoljava samo podatak sa ASCII karakterima

## v1.0.1 (rev. 16)
*Datum: 19.12.2022.*
 
- Rešen je problem koji je nastao kao posledica nedavno promenjenog načina rada servera Poreske uprave a odnosi se na
način obrade "zahteva za iščitavanje" (audit).
Problem je dovodio do povremenog izostanka slanja računa ka portalu Poreske uprave kod korisnika koji imaju veliki broj
izdatih računa (2-3 u minuti) i imaju izrazito nestabilnu internet konekciju (dugi i česti prekidi).

## v1.0.1 (rev. 15)
*Datum: 22.11.2022.*
 
- Ispravljen problem aktivacije licence

## v1.0.1 (rev. 14)
*Datum: 10.11.2022.*
 
- Čuvanje neispravnih paketa i nakon dobijene potvrde o uspešnom iščitavanju
- Ispravljen prikaz zahteva za fiskalizaciju računa u okviru strane za pregled računa u aplikaciji

## v1.0.1 (rev. 13)
*Datum: 07.10.2022.*

- Unapređeno detektovanje usklađenosti vremena L-PFR+ sa vremenom uređaja kao i unapređena detekcija promene vremena 
u periodu prelaska sa letnjeg na zimsko računanje vremena
***(Napomena: za korisnike kod kojih je računar na kome je instaliran L-PFR+ uključen u trenutku sezonske promene vremena 
preporučuje se ažururanje na ovu verziju kako bi se sprečio eventualni zastoj u fiskalizaciji)***
- Ispravljen način zaokruživanja ukupnog iznosa poreza kod prikaza na žurnalu
- Uklanjanje nepotrebnih instalacionih paketa nakon ažuriranja i/ili ponovnog startovanja servisa

## v1.0.1 (rev. 12)
*Datum: 12.09.2022.*

- Mogućnost pregleda informacija o izmenama u okviru servisnih informacija na klijentu
- Prikaz dodatnih informacija tokom procesa slanja dijagnostičkih podataka
- Unapređen proces ažuriranja i startovanja servisa na sporijim računarima 
i računarima sa velikim L-PFR+ bazama

## v1.0.1 (rev. 9, rev. 10, rev. 11)
*Datum: 25.08.2022.*
- Unapređenje automatskog ažuriranja
- Ispravljen problem mogućeg pogrešnog izbora poreske grupe nakon ažuriranja 
poreskih grupa od strane Poreske uprave.

## v1.0.1 (rev. 8)
*Datum: 11.08.2022.*

- Dodatne validacije kod prijema zahteva za fiskalizaciju:
    - Polje *payments* mora da sadrži najmanje jedan element
    - Polje *items* mora da sadrži najmanje jedan element
 
 - Dodatne validacije pre izvršavanja validnog zahteva za potpisivanje računa:
    - Ukoliko je slobodan skladišni prostor na particiji gde se nalazi L-PFR+ baza manji od dozvoljene 
    vrednosti (podrazumevana vrednost 1GB), L-PFR+ ne potpisuje račun i vraća grešku
    - Ukoliko vreme uređaja značajno odstupa od vremena dobijenog od NTP servera (više od 10 minuta), 
    L-PFR ne potpisuje račun i vraća grešku.

- Dodatni kodovi grešaka za probleme nastale u toku fiskalizacije računa:
    
    |Kod |Greška                     |Generisanje paketa*|
    |----|---------------------------|:-----------------:|
    |3100|InvalidTimeDetected        |Ne                 |
    |3101|StorageFull                |Ne                 |
    |3200|JournalNotGenerated        |Da                 |
    |3201|VerificationUrlNotGenerated|Da                 |
    |3202|QrCodeNotGenerated         |Da                 |
    |3203|Base64EncodingFailed       |Da                 |
    |3210|AuditPackageNotGenerated   |Ne                 |
    |3211|AuditPackageNotSaved       |Ne                 |
    
    *Ukoliko je paket generisan informacija o paketu se može dobiti pozivom metode *GetLastSignedInovoice*

    **Napomena: Obratiti pažnju da L-PFR+, od ove verzije, kada dođe do greške prilikom potpisivanja
    računa, a u zavisnosti od vrste greške, može da umesto koda 1999 vrati neki od gore 
    navedenih kodova koji preciznije opisuje problem.**

- Zaštita u slučaju dobijanja neispravnog vremena od NTP servera
- Pregled iz klijentske aplikacije statusa računa u L-PFR+ bazi
- Dodata mogućnost manuelne aktivacije licence
- Dodata mogućnost slanja dijagnostičkih podataka
- Promena podrazumevane dužine čuvanja paketa nakon uspešnog iščitavanja na 10 dana

## v1.0.1 (rev. 7)
*Datum: 14.05.2022.*
- Ispravljena greška kreiranja žurnala kada je ukupna dužina pojedinačne reči veća od dužine reda 
- Dodat osnovni pregled računa u bazi

## v1.0.1 (rev. 6)
*Datum: 26.04.2022.*
- Usaglešeni nazivi načina plaćanja sa pravilnikom - izbačena reč "Uplaćeno", "Kartica" -> "Platna kartica"
- Automatsko preuzimanje najnovije verzije programa

## v1.0.1 (rev. 5)
*Datum: 20.04.2022.*
- Ograničenje za RequestId prošireno na max 100 karaktera (sa 32), zbog kompatibilnosti sa starijim ESIR-ima

## v1.0.1 (rev. 4)
*Datum: 07.04.2022.*
- Dodatno logovanje validacije sertifikata 

## v1.0.1 (rev. 3)
*Datum: 07.04.2022.*
- Uključeni svi neophodni sertifikati za Windows i Android operativne sisteme

## v1.0.1 (rev. 2)
*Datum: 06.04.2022.*
- Dodatno logovanje validacije sertifikata licence servera

## v1.0.1 (rev. 1)
*Datum: 05.04.2022.*
- Žurnal se šalje u okviru audit paketa nezavisno od opcije *omitTextualRepresentation* u zahtevu za fiskalizaciju računa

## v1.0.0 (rev. 16)
*Datum: 24.03.2022.*
- Ispravljeno formatiranje rekapitaulacije poreskih stopa u žurnalu kada postoji stopa "Nije u PDV"
- Podrazumevana automatska instalacija produkcionih i razvojnih sertifikata
- Isključena validacija referentnog vremena. Referentno vreme se, kada je obavezno a nije poslato, zamenjuje trenutnim vremenom L-PFR-a prema dokumentaciji *"RucnoTestiranjeESIR-a_v5 0.pdf"*

## v1.0.0 (rev. 15)
*Datum: 15.03.2022.*
- Prikaz referentnog datuma i vremena na žurnalu u svim slučajevima kada je poslat od strane ESIR-a
- Usklađeni nazivi načina plaćanja na žurnalu sa "Pravilnikom o vrstama fiskalnih računa, tipovima transakcija, načinima plaćanja, pozivanju na broj drugog dokumenta i pojedinostima ostalih elemenata fiskalnog računa"

## v1.0.0 (rev. 14)
*Datum: 04.03.2022.*
- Dodatna ispravka problema povremenog zaglavljivanja servisa u slučaju kada se šalje VerifyPIN

## v1.0.0 (rev. 13)
*Datum: 03.03.2022.*
- U okviru podešavanja servisa dodata mogućnost definisanja velčine QR koda
- U okviru podešavanja servisa dodata podrška za https protokol
- Ispravka formatiranja načina plaćanja u žurnalu
- Rešen problem zaglavljivanja servisa u slučaju kada se šalje VerifyPIN u momentu izvršavanja komande dobijene sa servera

## v1.0.0 (rev. 12)
*Datum: 24.02.2022.*
- Ispravljeno neprikazivanje "ReferentDocumetntDT" podatka u žurnalu
- U žurnalu usaglašeni prevodi za načine plaćanja u skladu sa zvaničnom dokumentacijom ("Tehničko upuststvo za testiranje ESIR v5")
- Formatiranje količina artikala u žurnalu na tri decimalna mesta osim u slučaju kada su celobrojne vrednosti

## v1.0.0 (rev. 11)
*Datum: 22.02.2022.*
- Promenjen prevod u žurnalu sa "PIB kupca" na "ID kupca"
- U žurnalu dodat prevod "Opciono polje kupca"

## v1.0.0 (rev. 10)
*Datum: 03.02.2022.*
- Ograničena dužina parametra RequestId, koji se šalje kroz header zahteva za fiskalizaciju računa, na 32 karaktera, a u skladu sa izmenom u zvaničnoj dokumentaciji
- ESIR vreme se na generisanom žurnalu ispisuje samo kada je to vreme poslato sa ESIR-a
- Na generisanom žurnalu oznaka kraja bloka o poreskim stopama promenjena, u skladu sa zvaničnim primerom, sa dvostruke na jednostruku liniju
- U okviru generisanog žurnala, na odgovarajuća mesta i za odgovarajuće tipove računa, dodat tekst "Ovo nije fiskalni račun"

## v1.0.0 (rev. 9)
*Datum: 18.01.2021.*
- Ispravka ćirilićnog naziva ekstenzije računa kada je tip računa predračun

## v1.0.0 (rev. 8)
*Datum: 30.12.2021.*
- Usklađena preciznost vremena potpisivanja računa sa Tax Core serverom (sa nanosekundi na milisekunde)
- Usklađen format vremena u Tax Core autentifikacionom tokenu sa novom specifikacijom

## v1.0.0 (rev. 7)
*Datum: 16.12.2021.*
- Unapređena detekcija uključivanja/isključivanja eksternih uređaja
- Podrška za detekciju uključivanja/isključivanja eksternih uređaja i dodate odgovarajuće prateće akcije prema korisniku
- Usklađivanje perioda iščitavanja sa zvaničnim preporukama od 22.11.2021.
- Usklađivanje sa promenama strukture datoteke za uvoz komandi
- Dodata opcija za konfigurisanje načina JSON serijalizacije
- Prikaz na status panelu statistike vezane za rad i proces iščitavanja paketa
- Dodata numerička tastatura za lakši unos PIN-a kod ekrana osetljivih na dodir

## v1.0.0 (rev. 6)
*Datum: 30.10.2021.*
- Inicijalna verzija usklađena sa zahtevima propisanim zvaničnom dokumentacijom Poreske uprave

